﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing.Design;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.Design;

namespace PokTiles
{
    class ActionEditor: UITypeEditor
    {
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;
        }
        public override object EditValue(ITypeDescriptorContext context, System.IServiceProvider provider, object value)
        {
            IWindowsFormsEditorService svc = provider.GetService(typeof(IWindowsFormsEditorService)) as IWindowsFormsEditorService;
            ActionSprite actionSprite = value as ActionSprite;
            if (svc != null )
            {
                if (actionSprite == null) actionSprite = new ActionSprite("New Action");
                using (FormActionEditor form = new FormActionEditor())
                {
                    form.Action = actionSprite;
                    if (svc.ShowDialog(form) == DialogResult.OK)
                    {
                        actionSprite = form.Action; // update object
                    }
                }
            }
            return actionSprite; //value// can also replace the wrapper object here
        }
    }
}
