﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing.Design;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.Design;

namespace PokTiles
{
    class AnimationEditor: UITypeEditor
    {
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;
        }
        public override object EditValue(ITypeDescriptorContext context, System.IServiceProvider provider, object value)
        {
            IWindowsFormsEditorService svc = provider.GetService(typeof(IWindowsFormsEditorService)) as IWindowsFormsEditorService;
            AnimatedSprite animSprite = value as AnimatedSprite;
            if (svc != null )
            {
                if (animSprite == null) animSprite = new AnimatedSprite("New Animation");
                using (FormAnimationEditor form = new FormAnimationEditor())
                {
                    form.Animation = animSprite;
                    if (svc.ShowDialog(form) == DialogResult.OK)
                    {
                        animSprite = form.Animation; // update object
                    }
                }
            }
            return animSprite; //value// can also replace the wrapper object here
        }
    }
}
