﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PokTiles
{
    [Serializable]
    public class AppSettings
    {
        public static string FILENAME_SETTINGS = "AppSettings.json";
        public static string FILENAME_LAST_PALETTE = "LastPalette.json";
        public static string FILENAME_LAST_MAP = "LastMap.json";

        public SpriteSheet LoadedSpriteSheet { get; set; }

        private static AppSettings singleton;
        public static AppSettings Singleton()
        {
            if (singleton == null)
            {
                try
                {
                    var json = File.ReadAllText(FILENAME_SETTINGS);
                    singleton = JsonConvert.DeserializeObject<AppSettings>(json);
                }
                catch (Exception) { }
                if (singleton == null)
                    singleton = new AppSettings();
            }
            return singleton;
        }

        public static void Save()
        {
            var json = JsonConvert.SerializeObject(singleton, Formatting.Indented);
            File.WriteAllText(FILENAME_SETTINGS, json);
        }
    }
}
