﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PokTiles
{
    public partial class FormLoadSpriteSheet : Form
    {
        Image sourceImage;

        public FormLoadSpriteSheet()
        {
            InitializeComponent();
        }

        private void FormLoadSpriteSheet_Load(object sender, EventArgs e)
        {
            using (OpenFileDialog ofd = new OpenFileDialog())
            {
                if (ofd.ShowDialog() == DialogResult.OK)
                {
                    try
                    {
                        sourceImage = Image.FromFile(ofd.FileName);
                        UpdateTiles();
                    }
                    catch (Exception)
                    {
                        MessageBox.Show("Can't load image!");
                        Close();
                    }
                }
                else
                {
                    Close();
                }
            }
        }

        public SpriteSheet GetSpriteSheet()
        {
            return ucTilesMap.GetSpriteSheet();
        }

        private void UpdateTiles()
        {
            var ss = new SpriteSheet(sourceImage,
                (int)numTileWidth.Value,
                (int)numTileHeight.Value,
                cbUseTransparent.Checked);
            ucTilesMap.SetSpriteSheet(ss);

            lOutSize.Text = sourceImage.Width / (int)numTileWidth.Value +
                " x " +
                sourceImage.Height / (int)numTileHeight.Value;
        }

        private void numTileWidth_ValueChanged(object sender, EventArgs e)
        {
            UpdateTiles();
        }

        private void numTileHeight_ValueChanged(object sender, EventArgs e)
        {
            UpdateTiles();
        }

        private void BtnOk_Click(object sender, EventArgs e)
        {
            UpdateTiles();
            DialogResult = DialogResult.OK;
            Close();
        }
    }
}
