﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PokTiles
{
    [Serializable]
    public class Tile
    {
        [JsonConverter(typeof(ImageConverter))]
        public Image Sprite { get; set; }

        [CategoryAttribute(" ")]
        public int Id { get; set; }

        [CategoryAttribute("Render")]
        public bool FlipH { get; set; }
        [CategoryAttribute("Render")]
        public bool FlipV { get; set; }
        [CategoryAttribute("Render")]
        public bool Animated { get; set; }

        [CategoryAttribute("Engine")]
        public bool Solid { get; set; }
        [CategoryAttribute("Engine")]
        public bool OneWay { get; set; }
        [CategoryAttribute("Engine")]
        public bool Destructible { get; set; }
        [CategoryAttribute("Engine")]
        public bool Actioned { get; set; }
        [CategoryAttribute("Engine")]
        public bool Damaging { get; set; }

        [CategoryAttribute("Action")]
        public ActionSprite Actions { get; set; }

        [CategoryAttribute("Animation")]
        public AnimatedSprite Animation { get; set; }


        public void CopyFrom(Tile source)
        {
            if (source != null)
            {
                if (source.Sprite != null)
                    Sprite = (Image)source.Sprite.Clone();
                else
                    Sprite = null;

                Id = source.Id;

                FlipH = source.FlipH;
                FlipV = source.FlipV;
                Animated = source.Animated;

                Solid = source.Solid;
                OneWay = source.OneWay;
                Destructible = source.Destructible;
                Actioned = source.Actioned;
                Damaging = source.Damaging;

                Animated = source.Animated;
                Animation = source.Animation;// Utility.DeepClone(source.Animation);
                Actions = source.Actions;

                //TODO: iterate to copy all public properties and remove this hand copy

            }
        }

        public string ToJson()
        {
            return JsonConvert.SerializeObject(this);
        }

        public override string ToString()
        {
            return Id.ToString();
        }
    }
}
